#!/bin/bash

set -e

. /etc/profile

LOGFILE="/var/log/coremedia/upload_workflows.log"

if [ ! -e {{ wfs_tools_dir }}/bin/upload.jpif ]
then
  echo "cannot upload workflows, Workflow Server Tools not found at '{{ wfs_tools_dir}}'"
  exit 1
fi

if [ ! -e {{ deployment_tmp_directory }}/test-data/content ]
then
  echo "cannot upload workflows, content dir does not exist at '{{ deployment_tmp_directory }}/test-data/content'"
  exit 1
fi

builtin_workflows="{{ workflow_definitions_builtin | join(' ') }}"
custom_workflows="{{ workflow_definitions_custom | join(' ') }}"

if [ ! -e /etc/coremedia/workflows-uploaded ]
then

  echo "" > "${LOGFILE}"
  echo "builtin workflows" >> "${LOGFILE}"

  if [ ! -e etc/coremedia/workflows_builtin-uploaded ] && [ ! -z "${builtin_workflows}"  ]
  then

    {{ wfs_tools_dir }}/bin/cm upload \
      --user admin \
      --password admin \
      --definition \
      ${builtin_workflows} >> "${LOGFILE}"

    touch /etc/coremedia/workflows_builtin-uploaded

  fi

  echo "custom workflows" >> "${LOGFILE}"

  if [ ! -e etc/coremedia/workflows_custom-uploaded ]
  then

    for w in ${custom_workflows}
    do
      if [ -f ${w} ]
      then
        {{ wfs_tools_dir }}/bin/cm upload \
          --user admin \
          --password admin \
          --definition \
          ${w} >> "${LOGFILE}"

      else
        echo "cannot upload workflow from ${w}, file does not exist" >> "${LOGFILE}"
        continue
      fi
    done

    touch /etc/coremedia/workflows_custom-uploaded
  fi

  touch /etc/coremedia/workflows-uploaded

fi
